package common;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.sql.Date;
import java.util.Vector;

import domain.Offer;
import domain.RuralHouse;
import exceptions.BadDates;
import exceptions.OverlappingOfferExists;

public interface OfferInterface extends Remote {

	/**
	 * This method creates an offer with a house number, first day, last day and
	 * price
	 * 
	 * @param House
	 *            number, start day, last day and price
	 * @return the created offer, or null, or an exception
	 */
	public Offer createOffer(RuralHouse ruralHouse, Date firstDay,
			Date lastDay, float price) throws OverlappingOfferExists, BadDates,
			RemoteException, Exception;

	public void deleteOffer(RuralHouse rh, Offer o) throws RemoteException,
			Exception;
	
	public Vector<Offer> getRuralHouseOffers(RuralHouse rh)throws RemoteException;

}
